
#include <stm32f10x.h>              /* STM32F10x Library */


#include "w6100.h"						/* W6100 Register definition */
#include "w6100_init.h"
#include "SPI.h"
#include "socket.h"
#include "sntp.h"
#ifndef DATA_BUF_SIZE
	#define DATA_BUF_SIZE			2048
#endif
#define AS_IPV4 2
#define AS_IPV6 23
#define AS_IPDUAL 11

static uint16_t any_port = 	50000;
//static uint8_t curr_state[8] = {0,};
static uint8_t sock_state[8] = {0,};
char* msg_v4 = "IPv4 mode";
char* msg_v6 = "IPv6 mode";
char* msg_dual = "Dual IP mode";

int32_t loopback_udps(uint8_t sn, uint8_t* buf, uint16_t port, uint8_t loopback_mode);
int32_t loopback_tcps(uint8_t sn, uint8_t* buf, uint16_t port, uint8_t loopback_mode);
int32_t loopback_tcpc(uint8_t sn, uint8_t* buf, uint8_t* destip, uint16_t destport, uint8_t loopback_mode);
uint8_t buff[2048];
uint8_t buff1[2048];
uint8 reboot_flag = 0;
CONFIG_MSG ConfigMsg;
void dhcp_network(void);
/******************************************************************************/
/*******************           Main function             **********************/
/******************************************************************************/
int main(void)
{
		datetime time;
	
	uint8_t ntp_server[4] = {120,25,108,11}; 
	uint8_t ntp_server6[16]= {0x20,0x01,0x48,0x60,	
						0x48,0x06,0x00,0x00,
						0x00,0x00,0x00,0x00,
						0x00,0x00,0x00,0x00};

  /***Init system****/							  
	Systick_Init(72);	
	TimerInit();
	USART1_Init(); 		
	GPIO_Configuration();
	
#if _WIZCHIP_IO_MODE_ & _WIZCHIP_IO_MODE_BUS_INDIR_
	
	FSMC_Init();

#else	
	
	WIZ_SPI_Init();
	
#endif
	
	/***** reset 6100*****/
	Reset_W6100();
	
	/***** set net *****/
	Set_Network();		
  /*39 is time zone*/
  SNTP_init(ntp_server,39,buff,4);
    
   while (SNTP_run(1,&time,4,AS_IPV4) != 1);
	 printf("IPv4 NTP : %d-%d-%d, %d:%d:%d\r\n", time.yy, time.mo, time.dd, time.hh, time.mm, time.ss);
	 while(1);
	
}




